<?php

/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace Webkul\SalesforceConnector\Block\Adminhtml\System\Config;

class Config extends \Magento\Config\Block\System\Config\Form\Field
{

    // protected $_data;
    protected $_helper;

    public function __construct(
        // \Webkul\SalesforceConnector\Helper\Data $data,
        \Magento\Backend\Block\Template\Context $context,
        \Webkul\SalesforceConnector\Helper\Connection $helper,
        array $data = []
    ) {
        // $this->_data = $data;
        parent::__construct($context, $data);
        $this->_helper = $helper;
    }
    protected function _prepareLayout()
    {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate('Webkul_SalesforceConnector::system/config/config.phtml');
        }
        return $this;
    }

    /**
     * Unset some non-related element parameters
     *
     * @param \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    public function render(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Get the button and scripts contents
     *
     * @param \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    protected function _getElementHtml(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        return $this->_toHtml();
    }
    public function getOrgId()
    {
        if (isset($this->_helper->_sfconfigData['orgDetails']) && isset($this->_helper->_sfconfigData['orgDetails']['Id'])) {
            return $this->_helper->_sfconfigData['orgDetails']['Id'];
        } else {
            return '';
        }
    }
    public function getOrgName()
    {
        if (isset($this->_helper->_sfconfigData['orgDetails']) && isset($this->_helper->_sfconfigData['orgDetails']['Name'])) {
            return $this->_helper->_sfconfigData['orgDetails']['Name'];
        } else {
            return '';
        }
    }
    public function getConnUserName()
    {
        if (isset($this->_helper->_sfconfigData['userName']) && isset($this->_helper->_sfconfigData['userName']['Username'])) {
            return $this->_helper->_sfconfigData['userName']['Username'];
        } else {
            return '';
        }
    }
    public function getConnUser()
    {
        if (isset($this->_helper->_sfconfigData['userName']) && isset($this->_helper->_sfconfigData['userName']['Name'])) {
            return $this->_helper->_sfconfigData['userName']['Name'];
        } else {
            return '';
        }
    }
    public function getConnUserEmail()
    {
        if (isset($this->_helper->_sfconfigData['userName']) && isset($this->_helper->_sfconfigData['userName']['Email'])) {
            return $this->_helper->_sfconfigData['userName']['Email'];
        } else {
            return '';
        }
    }
}
