<?php

/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace Webkul\SalesforceConnector\Block\Adminhtml\System\Config;

class OrdMap extends \Magento\Config\Block\System\Config\Form\Field
{

    // protected $_data;
    protected $_helper;
    protected $_json;
    protected $_helperData;

    public function __construct(
        // \Webkul\SalesforceConnector\Helper\Data $data,
        \Magento\Backend\Block\Template\Context $context,
        \Webkul\SalesforceConnector\Helper\Connection $helper,
        \Magento\Framework\App\Helper\Context $helperContext,
        \Webkul\SalesforceConnector\Helper\Data $helperData,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        array $data = []
    ) {
        // $this->_data = $data;
        parent::__construct($context, $data);
        $this->_helper = $helper;
        $this->_json = $jsonHelper;
        $this->_helperData = $helperData;
        $this->_scopConfig = $helperContext->getScopeConfig();
    }
    protected function _prepareLayout()
    {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate('Webkul_SalesforceConnector::system/config/ordfieldmap.phtml');
        }
        return $this;
    }

    /**
     * Unset some non-related element parameters
     *
     * @param \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    public function render(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Get the button and scripts contents
     *
     * @param \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    protected function _getElementHtml(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        return $this->_toHtml();
    }

    public function getOrderObject()
    {
        $order = $this->_scopConfig
            ->getValue(
                'sfConnect/general/orderObject',
                \Magento\Store\Model\ScopeInterface::SCOPE_STORE
            );
        if ($order) {
            return $this->_json->jsonDecode($order);
        } else {
            return 0;
        }
    }
    public function getOrderTable()
    {
        return $this->_helperData->getTableColumn('sales_order');
    }
    public function getMappedOrder()
    {
        $order = $this->_scopConfig
            ->getValue(
                'sfConnect/ord/orderFieldMap',
                \Magento\Store\Model\ScopeInterface::SCOPE_STORE
            );
        if ($order) {
            return $this->_json->jsonDecode($order);
        } else {
            return 0;
        }
    }
}
