<?php

/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace Webkul\SalesforceConnector\Block\Adminhtml\System\Config;

class ProdMap extends \Magento\Config\Block\System\Config\Form\Field
{

    // protected $_data;
    protected $_helper;
    protected $_json;
    protected $_helperData;
    protected $_productCollectionFactory;
    protected $_attribute;

    public function __construct(
        // \Webkul\SalesforceConnector\Helper\Data $data,
        \Magento\Backend\Block\Template\Context $context,
        \Webkul\SalesforceConnector\Helper\Connection $helper,
        \Magento\Framework\App\Helper\Context $helperContext,
        \Webkul\SalesforceConnector\Helper\Data $helperData,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
       // \Magento\Catalog\Ui\DataProvider\Product\Attributes\Listing $attributes,
        \Magento\Catalog\Model\ResourceModel\Product\CollectionFactory $productCollectionFactory,
        array $data = []
    ) {
        // $this->_data = $data;
        parent::__construct($context, $data);
        $this->_helper = $helper;
        $this->_json = $jsonHelper;
     //   $this->_attribute = $attributes;
        $this->_productCollectionFactory = $productCollectionFactory;
        $this->_helperData = $helperData;
        $this->_scopConfig = $helperContext->getScopeConfig();
    }
    protected function _prepareLayout()
    {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate('Webkul_SalesforceConnector::system/config/prodfieldmap.phtml');
        }
        return $this;
    }

    /**
     * Unset some non-related element parameters
     *
     * @param \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    public function render(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Get the button and scripts contents
     *
     * @param \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    protected function _getElementHtml(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        return $this->_toHtml();
    }

    public function getProductObject()
    {
        $account = $this->_scopConfig
            ->getValue(
                'sfConnect/general/productObject',
                \Magento\Store\Model\ScopeInterface::SCOPE_STORE
            );
        if ($account) {
            return $this->_json->jsonDecode($account);
        } else {
            return 0;
        }
    }

    protected function setUp()
    {
        $objectManager = $objectManager = \Magento\Framework\App\ObjectManager::getInstance();

        $this->request = $objectManager->get(\Magento\Framework\App\RequestInterface::class);
        $this->dataProvider = $objectManager->create(
            \Magento\Catalog\Ui\DataProvider\Product\Attributes\Listing::class,
            [
                'name' => 'product_attributes_grid_data_source',
                'primaryFieldName' => 'attribute_id',
                'requestFieldName' => 'id',
                'request' => $this->request
            ]
        );
    }

    public function getProductTable()
    {
        // return $this->_helperData->getTableColumn('catalog_product_entity');
        $this->setUp();
        $this->dataProvider->addOrder('attribute_code', 'asc');
        $data = $this->dataProvider->getData();
        return $data['items'];
    }
    public function getMappedProduct()
    {
        $account = $this->_scopConfig
            ->getValue(
                'sfConnect/acc/productFieldMap',
                \Magento\Store\Model\ScopeInterface::SCOPE_STORE
            );
        if ($account) {
            return $this->_json->jsonDecode($account);
        } else {
            return 0;
        }
    }
    public function getProductCollection()
    {
        $collection = $this->_productCollectionFactory->create();
        $collection->addAttributeToSelect('*');
        // $collection->setPageSize(3); // fetching only 3 products
        return $collection;
    }
}
